diff --git a/libstdc++-v3/testsuite/20_util/duration/requirements/typedefs_neg3.cc b/libstdc++-v3/testsuite/20_util/duration/requirements/typedefs_neg3.cc
index 2369440..7fb022b 100644
--- a/libstdc++-v3/testsuite/20_util/duration/requirements/typedefs_neg3.cc
+++ b/libstdc++-v3/testsuite/20_util/duration/requirements/typedefs_neg3.cc
@@ -30,8 +30,7 @@ void test01()
   typedef int rep_type;
   typedef std::ratio<-1> period_type;
   typedef std::chrono::duration<rep_type, period_type> test_type;
-  test_type d;
+  test_type d;  // { dg-error "required from here" }
 }
 
 // { dg-error "period must be positive" "" { target *-*-* } 253 }
-// { dg-error "required from here" "" { target *-*-* } 33 }
diff --git a/libstdc++-v3/testsuite/20_util/headers/type_traits/types_std_c++0x_neg.cc b/libstdc++-v3/testsuite/20_util/headers/type_traits/types_std_c++0x_neg.cc
index 0696fad..fc9fbe5 100644
--- a/libstdc++-v3/testsuite/20_util/headers/type_traits/types_std_c++0x_neg.cc
+++ b/libstdc++-v3/testsuite/20_util/headers/type_traits/types_std_c++0x_neg.cc
@@ -22,15 +22,9 @@
 
 namespace gnu
 {
-  // C++0x changes from TR1.
-  using std::has_trivial_constructor;
-  using std::has_nothrow_constructor;
-  using std::has_trivial_copy;
-  using std::has_nothrow_copy;
+  // C++11 changes from TR1.
+  using std::has_trivial_constructor; // { dg-error "has not been declared" }
+  using std::has_nothrow_constructor; // { dg-error "has not been declared" }
+  using std::has_trivial_copy;	      // { dg-error "has not been declared" }
+  using std::has_nothrow_copy;	      // { dg-error "has not been declared" }
 }
-
-// { dg-error "has not been declared" "" { target *-*-* } 26 } 
-// { dg-error "has not been declared" "" { target *-*-* } 27 } 
-// { dg-error "has not been declared" "" { target *-*-* } 28 } 
-// { dg-error "has not been declared" "" { target *-*-* } 29 } 
-
diff --git a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/assign_neg.cc b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/assign_neg.cc
index 5f29e8e..1fa2106 100644
--- a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/assign_neg.cc
+++ b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/assign_neg.cc
@@ -1,6 +1,5 @@
 // { dg-do compile }
 // { dg-options "-std=gnu++11" }
-// { dg-error "no matching" "" { target *-*-* } 33 }
 
 // Copyright (C) 2009-2016 Free Software Foundation, Inc.
 //
@@ -30,5 +29,5 @@ void f()
 {
   typedef std::forward_list<A> test_type;
   test_type l;
-  l.assign(10, 1);
+  l.assign(10, 1); // { dg-error "no matching" }
 }
diff --git a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_1_neg.cc b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_1_neg.cc
index 15aeac7..829c84d 100644
--- a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_1_neg.cc
+++ b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_1_neg.cc
@@ -1,6 +1,5 @@
 // { dg-do compile }
 // { dg-options "-std=gnu++11" }
-// { dg-error "no matching" "" { target *-*-* } 27 }
 
 // Copyright (C) 2009-2016 Free Software Foundation, Inc.
 //
@@ -24,5 +23,5 @@
 void f()
 {
   typedef std::forward_list<std::forward_list<int> > test_type;
-  test_type l(10, 1);
+  test_type l(10, 1); // { dg-error "no matching" }
 }
diff --git a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_2_neg.cc b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_2_neg.cc
index 9a330a3..2ebcec3 100644
--- a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_2_neg.cc
+++ b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/constructor_2_neg.cc
@@ -1,6 +1,5 @@
 // { dg-do compile }
 // { dg-options "-std=gnu++11" }
-// { dg-error "no matching" "" { target *-*-* } 28 }
 
 // Copyright (C) 2009-2016 Free Software Foundation, Inc.
 //
@@ -25,5 +24,5 @@
 void f()
 {
   typedef std::forward_list<std::forward_list<std::pair<char, char> > > test_type;
-  test_type l('a', 'b');
+  test_type l('a', 'b'); // { dg-error "no matching" }
 }
diff --git a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/insert_neg.cc b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/insert_neg.cc
index 783feb8..cc2f2af 100644
--- a/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/insert_neg.cc
+++ b/libstdc++-v3/testsuite/23_containers/forward_list/requirements/dr438/insert_neg.cc
@@ -1,6 +1,5 @@
 // { dg-do compile }
 // { dg-options "-std=gnu++11" }
-// { dg-error "no matching" "" { target *-*-* } 33 }
 
 // Copyright (C) 2009-2016 Free Software Foundation, Inc.
 //
@@ -30,5 +29,5 @@ void f()
 {
   typedef std::forward_list<A> test_type;
   test_type l;
-  l.insert_after(l.begin(), 10, 1);
+  l.insert_after(l.begin(), 10, 1); // { dg-error "no matching" }
 }
diff --git a/libstdc++-v3/testsuite/26_numerics/headers/cmath/types_std_c++0x_neg.cc b/libstdc++-v3/testsuite/26_numerics/headers/cmath/types_std_c++0x_neg.cc
index 268832b..8910c7e 100644
--- a/libstdc++-v3/testsuite/26_numerics/headers/cmath/types_std_c++0x_neg.cc
+++ b/libstdc++-v3/testsuite/26_numerics/headers/cmath/types_std_c++0x_neg.cc
@@ -22,52 +22,28 @@
 
 namespace gnu
 {
-  // C++0x changes from TR1.
-  using std::assoc_laguerre;
-  using std::assoc_legendre;
-  using std::beta; 
-  using std::comp_ellint_1;
-  using std::comp_ellint_2;
-  using std::comp_ellint_3;
-  using std::conf_hyperg;
-  using std::cyl_bessel_i;
-  using std::cyl_bessel_j;
-  using std::cyl_bessel_k;
-  using std::cyl_neumann;
-  using std::ellint_1;
-  using std::ellint_2;
-  using std::ellint_3;
-  using std::expint;  
-  using std::hermite;
-  using std::hyperg;
-  using std::laguerre;
-  using std::legendre;
-  using std::riemann_zeta;
-  using std::sph_bessel;
-  using std::sph_legendre;
-  using std::sph_neumann;
+  // C++11 changes from TR1.
+  using std::assoc_laguerre;	// { dg-error "has not been declared" }
+  using std::assoc_legendre;	// { dg-error "has not been declared" }
+  using std::beta;		// { dg-error "has not been declared" }
+  using std::comp_ellint_1;	// { dg-error "has not been declared" }
+  using std::comp_ellint_2;	// { dg-error "has not been declared" }
+  using std::comp_ellint_3;	// { dg-error "has not been declared" }
+  using std::conf_hyperg;	// { dg-error "has not been declared" }
+  using std::cyl_bessel_i;	// { dg-error "has not been declared" }
+  using std::cyl_bessel_j;	// { dg-error "has not been declared" }
+  using std::cyl_bessel_k;	// { dg-error "has not been declared" }
+  using std::cyl_neumann;	// { dg-error "has not been declared" }
+  using std::ellint_1;		// { dg-error "has not been declared" }
+  using std::ellint_2;		// { dg-error "has not been declared" }
+  using std::ellint_3;		// { dg-error "has not been declared" }
+  using std::expint;		// { dg-error "has not been declared" }
+  using std::hermite;		// { dg-error "has not been declared" }
+  using std::hyperg;		// { dg-error "has not been declared" }
+  using std::laguerre;		// { dg-error "has not been declared" }
+  using std::legendre;		// { dg-error "has not been declared" }
+  using std::riemann_zeta;	// { dg-error "has not been declared" }
+  using std::sph_bessel;	// { dg-error "has not been declared" }
+  using std::sph_legendre;	// { dg-error "has not been declared" }
+  using std::sph_neumann;	// { dg-error "has not been declared" }
 }
-
-// { dg-error "has not been declared" "" { target *-*-* } 26 } 
-// { dg-error "has not been declared" "" { target *-*-* } 27 } 
-// { dg-error "has not been declared" "" { target *-*-* } 28 } 
-// { dg-error "has not been declared" "" { target *-*-* } 29 } 
-// { dg-error "has not been declared" "" { target *-*-* } 30 } 
-// { dg-error "has not been declared" "" { target *-*-* } 31 } 
-// { dg-error "has not been declared" "" { target *-*-* } 32 } 
-// { dg-error "has not been declared" "" { target *-*-* } 33 } 
-// { dg-error "has not been declared" "" { target *-*-* } 34 } 
-// { dg-error "has not been declared" "" { target *-*-* } 35 } 
-// { dg-error "has not been declared" "" { target *-*-* } 36 } 
-// { dg-error "has not been declared" "" { target *-*-* } 37 } 
-// { dg-error "has not been declared" "" { target *-*-* } 38 } 
-// { dg-error "has not been declared" "" { target *-*-* } 39 } 
-// { dg-error "has not been declared" "" { target *-*-* } 40 } 
-// { dg-error "has not been declared" "" { target *-*-* } 41 } 
-// { dg-error "has not been declared" "" { target *-*-* } 42 } 
-// { dg-error "has not been declared" "" { target *-*-* } 43 } 
-// { dg-error "has not been declared" "" { target *-*-* } 44 } 
-// { dg-error "has not been declared" "" { target *-*-* } 45 } 
-// { dg-error "has not been declared" "" { target *-*-* } 46 } 
-// { dg-error "has not been declared" "" { target *-*-* } 47 } 
-// { dg-error "has not been declared" "" { target *-*-* } 48 } 
diff --git a/libstdc++-v3/testsuite/26_numerics/random/linear_congruential_engine/requirements/non_uint_neg.cc b/libstdc++-v3/testsuite/26_numerics/random/linear_congruential_engine/requirements/non_uint_neg.cc
index 6f4f272..3c7f7bf 100644
--- a/libstdc++-v3/testsuite/26_numerics/random/linear_congruential_engine/requirements/non_uint_neg.cc
+++ b/libstdc++-v3/testsuite/26_numerics/random/linear_congruential_engine/requirements/non_uint_neg.cc
@@ -21,11 +21,10 @@
 // { dg-do compile }
 // { dg-options "-std=gnu++11" }
 // { dg-require-cstdint "" }
-// { dg-error "not a valid type" "" { target *-*-* } 31 }
 
 // 26.4.3.1 class template linear_congruential_engine [rand.eng.lcong]
 // 26.4.2.2 Concept RandomNumberEngine [rand.concept.eng]
 
 #include <random>
 
-std::linear_congruential_engine<double, 48271, 0, 2147483647> x;
+std::linear_congruential_engine<double, 48271, 0, 2147483647> x; // { dg-error "not a valid type" }
diff --git a/libstdc++-v3/testsuite/29_atomics/headers/atomic/types_std_c++0x_neg.cc b/libstdc++-v3/testsuite/29_atomics/headers/atomic/types_std_c++0x_neg.cc
index 5f79943..dbea9b9 100644
--- a/libstdc++-v3/testsuite/29_atomics/headers/atomic/types_std_c++0x_neg.cc
+++ b/libstdc++-v3/testsuite/29_atomics/headers/atomic/types_std_c++0x_neg.cc
@@ -23,101 +23,56 @@
 void test01()
 {
   // Not global scoped, only namespace std.
-  using memory_order;
-  using memory_order_relaxed;
-  using memory_order_consume;
-  using memory_order_acquire;
-  using memory_order_release;
-  using memory_order_acq_rel;
-  using memory_order_seq_cst;
+  using memory_order;		// { dg-error "expected nested-name-specifier" }
+  using memory_order_relaxed;	// { dg-error "expected nested-name-specifier" }
+  using memory_order_consume;	// { dg-error "expected nested-name-specifier" }
+  using memory_order_acquire;	// { dg-error "expected nested-name-specifier" }
+  using memory_order_release;	// { dg-error "expected nested-name-specifier" }
+  using memory_order_acq_rel;	// { dg-error "expected nested-name-specifier" }
+  using memory_order_seq_cst;	// { dg-error "expected nested-name-specifier" }
 
-  using atomic_flag;
+  using atomic_flag;		// { dg-error "expected nested-name-specifier" }
 
-  using atomic_bool;
-  using atomic_char;
-  using atomic_schar;
-  using atomic_uchar;
-  using atomic_short;
-  using atomic_ushort;
-  using atomic_int;
-  using atomic_uint;
-  using atomic_long;
-  using atomic_ulong;
-  using atomic_llong;
-  using atomic_ullong;
-  using atomic_wchar_t;
-  using atomic_char16_t;
-  using atomic_char32_t;
+  using atomic_bool;		// { dg-error "expected nested-name-specifier" }
+  using atomic_char;		// { dg-error "expected nested-name-specifier" }
+  using atomic_schar;		// { dg-error "expected nested-name-specifier" }
+  using atomic_uchar;		// { dg-error "expected nested-name-specifier" }
+  using atomic_short;		// { dg-error "expected nested-name-specifier" }
+  using atomic_ushort;		// { dg-error "expected nested-name-specifier" }
+  using atomic_int;		// { dg-error "expected nested-name-specifier" }
+  using atomic_uint;		// { dg-error "expected nested-name-specifier" }
+  using atomic_long;		// { dg-error "expected nested-name-specifier" }
+  using atomic_ulong;		// { dg-error "expected nested-name-specifier" }
+  using atomic_llong;		// { dg-error "expected nested-name-specifier" }
+  using atomic_ullong;		// { dg-error "expected nested-name-specifier" }
+  using atomic_wchar_t;		// { dg-error "expected nested-name-specifier" }
+  using atomic_char16_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_char32_t;	// { dg-error "expected nested-name-specifier" }
 
-  using atomic_int_least8_t;
-  using atomic_uint_least8_t;
-  using atomic_int_least16_t;
-  using atomic_uint_least16_t;
-  using atomic_int_least32_t;
-  using atomic_uint_least32_t;
-  using atomic_int_least64_t;
-  using atomic_uint_least64_t;
-  using atomic_int_fast8_t;
-  using atomic_uint_fast8_t;
-  using atomic_int_fast16_t;
-  using atomic_uint_fast16_t;
-  using atomic_int_fast32_t;
-  using atomic_uint_fast32_t;
-  using atomic_int_fast64_t;
-  using atomic_uint_fast64_t;
-  using atomic_intptr_t;
-  using atomic_uintptr_t;
-  using atomic_size_t;
-  using atomic_ptrdiff_t;
-  using atomic_intmax_t;
-  using atomic_uintmax_t;
+  using atomic_int_least8_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_least8_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_int_least16_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_least16_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_int_least32_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_least32_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_int_least64_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_least64_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_int_fast8_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_fast8_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_int_fast16_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_fast16_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_int_fast32_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_fast32_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_int_fast64_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uint_fast64_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_intptr_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uintptr_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_size_t;		// { dg-error "expected nested-name-specifier" }
+  using atomic_ptrdiff_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_intmax_t;	// { dg-error "expected nested-name-specifier" }
+  using atomic_uintmax_t;	// { dg-error "expected nested-name-specifier" }
 
-  using atomic_address;
+  using atomic_address;		// { dg-error "expected nested-name-specifier" }
+  // Present in C++0x drafts but not final C++11 standard:
+  using std::atomic_address;	// { dg-error "has not been declared" }
 }
-
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 26 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 27 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 28 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 29 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 30 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 31 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 32 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 34 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 36 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 37 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 38 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 39 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 40 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 41 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 42 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 43 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 44 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 45 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 46 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 47 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 48 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 49 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 50 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 52 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 53 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 54 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 55 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 56 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 57 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 58 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 59 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 60 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 61 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 62 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 63 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 64 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 65 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 66 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 67 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 68 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 69 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 70 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 71 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 72 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 73 }
-// { dg-error "expected nested-name-specifier" "" { target *-*-* } 75 }